local HardFinger = _G.HardFinger

local P = HardFinger.HardFinger_Config
--------------------------------------------------------------------------------------------------------
--                                          Left Buttons                                              --
--------------------------------------------------------------------------------------------------------
local activePage = 1;
local frames = {};
options = {
	-- General
	{
		[0] = "General",
		{ type = "Check", id=1, var = "Status", label = "STATUS - Toggles the addon on/off", tip = "y" },
		{ type = "Check", id=2, var = "WhoPulled", label = "WHOPULLED - Announces who aggroed non-friendly mobs", tip = "The first spell debuff, spell damage or melee on each non-friendly mob will be announced on the proper channnel", y = 8 },
		{ type = "Check", id=3, var = "BloodLust", label = "BLOODLUST - Announces who used Blood Lust (and similars) or Drums", tip = "x" },
		{ type = "Check", id=4, var = "BattleRez", label = "BATTLE REZ - Announces the source and destination from used battle rezzes", tip = "y" },
		{ type = "Check", id=5, var = "Taunt", label = "TAUNT - Announces taunts", tip = "y" },
		{ type = "Check", id=6, var = "TimeToDie", label = "TIME TO DIE - Shows estimation of how long it will take for your target to die", tip = "y" },


		{ type = "DropDown", id=7, var = "PrivateChannel", label = "Private Channel", listName = "ListOfChannels"},
		--{ type = "DropDown", var = "showRealm", label = "Show Unit Realm", list = { ["Do not show realm"] = "none", ["Show realm"] = "show", ["Show (*) instead"] = "asterisk" } },
		--{ type = "DropDown", var = "showTarget", label = "Show Unit Target", list = { ["Do not show target"] = "none", ["First line"] = "first", ["Second line"] = "second", ["Last line"] = "last" }, y = 16 },
		--{ type = "Text", id=8, var = "targetYouText", label = "Targeting You Text" },
	},
	-- General
	{
		[0] = "Night Hold",
		{ type = "DropDown", id=9, children_ids = {10, 11, 12, 13, 14, 15, 16, 17, 18}, var = "dropDownSelectedBoss", label = "             Select Boss", list = { ["1. Skorpyron"] = "Skorpyron", ["2. Chronomatic Anomaly"] = "Chronomatic Anomaly", ["3. Trilliax"] = "Trilliax", ["12. Gul'dan"] = "Gul'dan"} },
		{ type = "Check", id=10, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=11, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=12, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=13, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=14, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=15, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=16, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=17, var = nil, label = "", tip = nil, bossName = nil },
		{ type = "Check", id=18, var = nil, label = "", tip = nil, bossName = nil },
	},
}

function HardFinger.UpdateOptions(page, id, variableToChange, newValue)
	for k, v in pairs(options[page]) do
		if options[page][k].id == id then
			id = k
			end
	end
	options[page][id][variableToChange] = newValue
	return
end
--------------------------------------------------------------------------------------------------------
--                                          Initialize Frame                                          --
--------------------------------------------------------------------------------------------------------

--function HardFinger.InitiliazeOptionsFrame()
local f = CreateFrame("Frame","HardFingerOptions",UIParent);

f.options = options;

f:SetWidth(700);
f:SetHeight(378);	-- "18" per category entry
f:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 16, edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } });
f:SetBackdropColor(0.1,0.22,0.35,1);
f:SetBackdropBorderColor(0.1,0.1,0.1,1);
f:EnableMouse(true);
f:SetMovable(true);
f:SetFrameStrata("DIALOG");
f:SetToplevel(true);
f:SetClampedToScreen(true);
f:SetScript("OnShow",function() f:BuildCategoryPage(); end);
f:Hide();

f.outline = CreateFrame("Frame",nil,f);
f.outline:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = 1, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
f.outline:SetBackdropColor(0.1,0.1,0.2,1);
f.outline:SetBackdropBorderColor(0.8,0.8,0.9,0.4);
f.outline:SetPoint("TOPLEFT",12,-12);
f.outline:SetPoint("BOTTOMLEFT",12,12);
f.outline:SetWidth(84);

f:SetScript("OnMouseDown",function() f:StartMoving() end);
f:SetScript("OnMouseUp",function() f:StopMovingOrSizing(); P.optionsLeft = f:GetLeft(); P.optionsBottom = f:GetBottom(); end);

if (P.optionsLeft) and (P.optionsBottom) then
	f:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",P.optionsLeft,P.optionsBottom);
else
	f:SetPoint("CENTER");
end

f.header = f:CreateFontString(nil,"ARTWORK","GameFontHighlight");
f.header:SetFont(GameFontNormal:GetFont(),22,"THICKOUTLINE");
f.header:SetPoint("TOPLEFT",f.outline,"TOPRIGHT",10,-4);
f.header:SetText("HardFinger - Options");

f.vers = f:CreateFontString(nil,"ARTWORK","GameFontNormal");
f.vers:SetPoint("TOPRIGHT",-20,-20);
f.vers:SetText(GetAddOnMetadata("HardFinger","Version"));
f.vers:SetTextColor(1,1,0.5);

local function Reset_OnClick(self)
	for index, tbl in ipairs(options[activePage]) do
		if (tbl.var) then
			P[tbl.var] = nil;
		end
	end
	TipTac:ApplySettings();
	f:BuildCategoryPage();
end

f.btnAnchor = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnAnchor:SetWidth(75);
f.btnAnchor:SetHeight(24);
f.btnAnchor:SetPoint("BOTTOMLEFT",f.outline,"BOTTOMRIGHT",10,3);
f.btnAnchor:SetScript("OnClick",function() if (TipTac:IsVisible()) then TipTac:Hide(); else TipTac:Show(); end end);
f.btnAnchor:SetText("Anchor");

f.btnReset = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnReset:SetWidth(75);
f.btnReset:SetHeight(24);
f.btnReset:SetPoint("LEFT",f.btnAnchor,"RIGHT",38,0);
f.btnReset:SetScript("OnClick", Reset_OnClick);
f.btnReset:SetText("Defaults");

f.btnDisplayFailTable = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnDisplayFailTable:SetWidth(120);
f.btnDisplayFailTable:SetHeight(24);
f.btnDisplayFailTable:SetPoint("LEFT",f.btnAnchor,"RIGHT",113,0);
f.btnDisplayFailTable:SetScript("OnClick",HardFinger.DisplayFailTable);
f.btnDisplayFailTable:SetText("Report Fail Table");

f.btnClose = CreateFrame("Button",nil,f,"UIPanelButtonTemplate");
f.btnClose:SetWidth(75);
f.btnClose:SetHeight(24);
f.btnClose:SetPoint("BOTTOMRIGHT",-15,15);
f.btnClose:SetScript("OnClick",function() f:Hide() HardFinger.SaveVariables(); end);
f.btnClose:SetText("Close");

UISpecialFrames[#UISpecialFrames + 1] = f:GetName();

--end

--------------------------------------------------------------------------------------------------------
--                                        Options Category List                                       --
--------------------------------------------------------------------------------------------------------

local listButtons = {};

local function List_OnClick(self,button)
	listButtons[activePage].text:SetTextColor(1,0.82,0);
	listButtons[activePage]:UnlockHighlight();
	activePage = self.index;
	self.text:SetTextColor(1,1,1);
	self:LockHighlight();
	PlaySound("igMainMenuOptionCheckBoxOn");
	f:BuildCategoryPage();
end

local buttonWidth = (f.outline:GetWidth() - 8);
local function MakeListEntry()
	local b = CreateFrame("Button",nil,f.outline);
	b:SetWidth(buttonWidth);
	b:SetHeight(18);
	b:SetScript("OnClick",List_OnClick);
	b:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight");
	b:GetHighlightTexture():SetAlpha(0.7);
	b.text = b:CreateFontString(nil,"ARTWORK","GameFontNormal");
	b.text:SetPoint("LEFT",3,0);
	listButtons[#listButtons + 1] = b;
	return b;
end

local button;
for index, table in ipairs(options) do
	button = listButtons[index] or MakeListEntry();
	button.text:SetText(table[0]);
	button.index = index;
	if (index == 1) then
		button:LockHighlight();
		button.text:SetTextColor(1,1,1);
		button:SetPoint("TOPLEFT",f.outline,"TOPLEFT",5,-6);
	else
		button:SetPoint("TOPLEFT",listButtons[index - 1],"BOTTOMLEFT");
	end
end

--------------------------------------------------------------------------------------------------------
--                                        Build Option Category                                       --
--------------------------------------------------------------------------------------------------------

local function ChangeSettingFunc(self,var,value, bossName)
	if (not ignoreConfigUpdate) then
		if bossName ~= nil then
			P["EncountersOptions"] = P["EncountersOptions"] or {};
			P["EncountersOptions"][bossName] = P["EncountersOptions"][bossName] or {};
			P["EncountersOptions"][bossName][var] = value;
		else
			P[var] = value;
		end
		--TipTac:ApplySettings();
	end
end

local factory = AzOptionsFactory:New(f,nil,ChangeSettingFunc);

-- Build Page
function HardFinger.GUI()
	f:BuildCategoryPage();
	print("f:BuildCategoryPage() called")
end

function f:BuildCategoryPage()
	AzDropDown:HideMenu();
	factory:ResetObjectUse();
	local frame;
	local yOffset = -38;
	-- Loop Through Options
	ignoreConfigUpdate = 1;
	for index, option in ipairs(options[activePage]) do
		if options[activePage][index].label ~= "" then -- Skip iteration if object is meant to be invisible
			-- Init & Setup the Frame
			frame = factory:GetObject(option.type);
			frame.option = option;
			frame.text:SetText(option.label);
			-- slider
			if (option.type == "Slider") then
				frame.slider:SetMinMaxValues(option.min,option.max);
				frame.slider:SetValueStep(option.step);
				frame.slider:SetValue(P[option.var]);
				frame.edit:SetNumber(P[option.var]);
				frame.low:SetText(option.min);
				frame.high:SetText(option.max);
			-- check
			elseif (option.type == "Check") then
				frame:SetHitRectInsets(0,frame.text:GetWidth() * -1,0,0);
				if option.bossName ~= nil then
					if (P.EncountersOptions[option.bossName][option.var]) == nil then
						frame:SetChecked(false);
					else
						frame:SetChecked(P.EncountersOptions[option.bossName][option.var]);
					end
				else
					frame:SetChecked(P[option.var]);
				end
			-- color
			elseif (option.type == "Color") then
				frame:SetHitRectInsets(0,frame.text:GetWidth() * -1,0,0);
				if (option.subType == 2) then
					frame.color[1], frame.color[2], frame.color[3], frame.color[4] = factory:HexStringToRGBA(P[option.var]);
				else
					frame.color[1], frame.color[2], frame.color[3], frame.color[4] = unpack(P[option.var]);
				end
				frame.texture:SetVertexColor(frame.color[1],frame.color[2],frame.color[3],frame.color[4] or 1);
			-- dropdown
			elseif (option.type == "DropDown") then
	--			frame.InitFunc = (option.init or option.media and HardFingerDropDowns.SharedMediaLib_Init or HardFingerDropDowns.Default_Init);
				frame.InitFunc = HardFingerDropDowns.Default_Init;
				frame:InitSelectedItem(P[option.var]);
			-- text
			elseif (option.type == "Text") then
				--frame:SetText(P[option.var]:gsub("|","||"));
			end
			-- Anchor the Frame
			frame:ClearAllPoints();
			frame:SetPoint("TOPLEFT",f.outline,"TOPRIGHT",factory.objectOffsetX[option.type] + (option.x or 0),yOffset);
			yOffset = (yOffset - frame:GetHeight() - factory.objectOffsetY[option.type] - (option.y or 0));
			-- Show
			frame:Show();
		end
	end
	-- End Update
	ignoreConfigUpdate = nil;
end